/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2010 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 *******************************************************************************
 *
 * $Id$
 *
 ******************************************************************************/
package it.tidalwave.semantic.node.impl;

import javax.annotation.Nonnull;
import java.util.Collection;
import java.util.Collections;
import it.tidalwave.semantic.other.Entity;
import it.tidalwave.netbeans.capabilitiesprovider.CapabilitiesProviderSupport;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class EntityNodeCapabilitiesProvider extends CapabilitiesProviderSupport<Entity>
  {
    public EntityNodeCapabilitiesProvider()
      {
        super(Entity.class);
      }

    @Override
    @Nonnull
    public Collection<? extends Object> createCapabilities (@Nonnull final Entity entity)
      {
        return Collections.singletonList(new EntityNodeDelegateFactoryImpl(entity));
      }
  }
